## emacs-pg-el 0.48

=== test/Makefile ===
EMACS ?= emacs
DOCKER ?= podman
WORKDIR := $(shell mktemp -d)

# export DEPS_DIR = $(shell realpath .deps)
export DEPS_DIR := $(shell mktemp -d --tmpdir emacsdepsXXXX)

default: test

# Note: we have to include test/ in test/install-deps.el because when we load ../pg.el we change the
# current directory to the parent of test.
.PHONY: install-deps
install-deps:
	${EMACS} -Q --batch ../pg.el -l test/install-deps.el

test: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el ../pg.el \
	   -l pg.el -l pg-geometry.el -l pg-gis.el -l test-pg.el -f pg-test

test-interactive: test-pg.el install-deps
	${EMACS} -Q -L .. -L . -l load-deps.el ../pg.el \
	   -l pg.el -l pg-geometry.el -l pg-gis.el -l test-pg.el -f pg-test

supabase: install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l supabase.el -f test-supabase

hang: install-deps
	${EMACS} -Q -L .. -L . -l load-deps.el -l ../pg.el -l hang.el

# Run tests over an encrypted connection to PostgreSQL. Encryption is not available for all versions
# and installations (the PostgreSQL backend needs to be set up with TLS certificates), so this is a
# separate test target.
test-tls: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls

test-tls-direct: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls-direct


# Run tests over a local Unix socket connection to PostgreSQL.
test-local: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-local

test-ebiacuk: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-ebiacuk


test-connections: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-connection-tests

test-multithreaded: test-pg.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-multithreaded.el -f pgtest-multithreaded

test-pgvector: test-pgvector.el install-deps
	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pgvector.el -f pg-test


# Using Docker images for Emacs from https://hub.docker.com/r/silex/emacs/ and the locally installed
# PostgreSQL.
test-emacs-dev: test-pg.el
	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el test-pg.el ${WORKDIR}
	${DOCKER} run --rm -it \
	   -v ${WORKDIR}:/tmp \
	   -e DEPS_DIR=/tmp/deps \
	   -e PGEL_HOSTNAME=10.0.2.2 \
	   --network slirp4netns:allow_host_loopback=true \
	   docker.io/silex/emacs:master-alpine-ci \
	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l ../tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/test-pg.el -f pg-test

test-emacs28: test-pg.el
	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el test-pg.el ${WORKDIR}
	${DOCKER} run --rm -it \
	   -v ${WORKDIR}:/tmp \
	   -e DEPS_DIR=/tmp/deps \
	   -e PGEL_HOSTNAME=10.0.2.2 \
	   --network slirp4netns:allow_host_loopback=true \
	   docker.io/silex/emacs:28.1 \
	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/test-pg.el -f pg-test

# The peg.el library doesn't actually compile with Emacs 27 (void-function byte-run--set-speed), so
# this doesn't work.
test-emacs27: test-pg.el
	cp install-deps.el load-deps.el ../pg.el test-pg.el ${WORKDIR}
	${DOCKER} run --rm -it \
	   -v ${WORKDIR}:/tmp \
	   -e DEPS_DIR=/tmp/deps \
	   -e PGEL_HOSTNAME=10.0.2.2 \
	   --network slirp4netns:allow_host_loopback=true \
	   docker.io/silex/emacs:27.2 \
	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/test-pg.el -f pg-test

# The extended query support will not work in Emacs versions before 28.1, because functionality
# provided by the bindat libary is needed. However, other functionality based on the simple query
# protocol (the pg-exec function) should work fine.
test-emacs26: test-pg.el
	cp install-deps.el load-deps.el ../pg.el test-pg.el ${WORKDIR}
	${DOCKER} run --rm -it \
	   -v ${WORKDIR}:/tmp \
	   -e DEPS_DIR=/tmp/deps \
	   -e PGEL_HOSTNAME=10.0.2.2 \
	   --network slirp4netns:allow_host_loopback=true  \
	   docker.io/silex/emacs:26.3-alpine-ci \
	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/test-pg.el -f pg-test

# Emacs versions older than 26.1 will not work against a recent PostgreSQL version (that is set up
# to require SCRAM-SHA-256 authentication), because they don't include the GnuTLS support which we
# use to calculate HMACs. They may however work against a database set up to not require
# authentication for local connections.
test-emacs25: test-pg.el
	cp ../pg.el test-pg.el ${WORKDIR}
	${DOCKER} run --rm -it \
	   -v ${WORKDIR}:/tmp \
	   -e DEPS_DIR=/tmp/deps \
	   -e PGEL_HOSTNAME=10.0.2.2 \
	   --network slirp4netns:allow_host_loopback=true \
	   docker.io/silex/emacs:25.3 \
	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/test-pg.el -f pg-test

test-postgresql17: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5426:5426 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5426 \
	   -e TZ=Asia/Tokyo \
	   -d docker.io/library/postgres:17-alpine
	sleep 5
	PGEL_PORT=5426 $(MAKE) test
	${DOCKER} stop pgsql

# A special test for short usernames, database names, passwords and so on (we used to have some
# builtin assumptions that a username was a least 4 chars in length).
test-shortnames: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5926:5926 \
	   -e POSTGRES_DB=d \
	   -e POSTGRES_USER=u \
	   -e POSTGRES_PASSWORD=~ \
	   -e PGPORT=5926 \
	   -d docker.io/library/postgres:14
	sleep 5
	PGEL_PORT=5926 PGEL_DATABASE=d PGEL_USER=u PGEL_PASSWORD="~" $(MAKE) test
	${DOCKER} stop pgsql

test-postgresql16: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5416:5416 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5416 \
	   -e TZ=Asia/Tokyo \
	   -d docker.io/library/postgres:16-alpine
	sleep 5
	TZ=Asia/Tokyo PGEL_PORT=5416 $(MAKE) test
	${DOCKER} stop pgsql

test-postgresql15: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5116:5116 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5116 \
	   -d docker.io/library/postgres:15
	sleep 5
	PGEL_PORT=5116 $(MAKE) test
	${DOCKER} stop pgsql

test-postgresql14: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5439:5439 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5439 \
	   -d docker.io/library/postgres:14
	sleep 5
	PGEL_PORT=5439 $(MAKE) test
	${DOCKER} stop pgsql

test-postgresql13: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5439:5439 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5439 \
	   -d docker.io/library/postgres:13-alpine
	sleep 5
	PGEL_PORT=5439 $(MAKE) test
	${DOCKER} stop pgsql

test-postgresql12: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5439:5439 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5439 \
	   -d docker.io/library/postgres:12-alpine
	sleep 5
	PGEL_PORT=5439 $(MAKE) test
	${DOCKER} stop pgsql

test-postgresql11: test-pg.el
	${DOCKER} run --rm --name pgsql \
	   --publish 5437:5437 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5437 \
	   -d docker.io/library/postgres:11-alpine
	sleep 5
	PGEL_PORT=5437 $(MAKE) test
	${DOCKER} stop pgsql


# EDB with a Red Hat Universal Base Image. This defaults to an SQL_ASCII client-encoding unless we
# set LC_CTYPE.
#
# https://github.com/EnterpriseDB/docker-postgresql
test-enterprisedb: test-pg.el
	${DOCKER} run --rm --name edb \
	   --publish 5366:5366 \
	   -e TZ=UTC-7:00 \
	   -e LANG=en_US.UTF8 \
	   -e LC_CTYPE=en_US.UTF8 \
	   -e POSTGRES_DB=pgeltestdb \
	   -e POSTGRES_USER=pgeltestuser \
	   -e POSTGRES_PASSWORD=pgeltest \
	   -e PGPORT=5366 \
	   -d ghcr.io/enterprisedb/postgresql:17
	TZ=UTC-7:00 PGEL_PORT=5366 $(MAKE) test
	${DOCKER} stop edb


# Tests with a PostgreSQL server configured to only accept clients that present a CA-signed certificate.
#
#   https://www.postgresql.org/docs/current/ssl-tcp.html
#
# We use openssl to generate a new Root certificate authority and key. Use the root CA to create a
# server certificate and key and a client certificate and key. Start PostgreSQL with the server
# certificate and the root CA certificate, configured to require clients to present a client
# certificate signed by our root CA. Connect presenting the client certificate (this uses the GnuTLS
# support for client certificates in Emacs).
#
# Note: mounting the pgcerts volume with the :U modifier maps the file owner for all volume files to
# that selected by the container ("postgres"), which is required for PostgreSQL to accept that the
# server certificate key is not readable by other users.
#
# https://github.com/bitnami/containers/blob/main/bitnami/postgresql/README.md
#
# The Bitnami configuration for pg_hba.conf deletes all lines with authentication methods
# local, or md5, or trust (our value for POSTGRESQL_PHHBA_REMOVE_FILTERS), and adds a line
#
#   hostssl     all             all             0.0.0.0/0               cert
#
# This means the equivalent of clientcert=verify-full, meaning that the server will verify that the
# client certificate is signed by its root CA (configured as /certs/root.crt below) and will also
# verify that the username specified in the CN field of the certificate corresponds to the
# PostgreSQL username we are connecting as.
test-certificates: test-pg.el install-deps
	openssl req -new -nodes -text -out ${WORKDIR}/root.csr -keyout ${WORKDIR}/root.key \
	   -subj "/CN=localhost"
	chmod og-rwx ${WORKDIR}/root.key
	openssl x509 -req -in ${WORKDIR}/root.csr -text -days 42 \
	   -extfile /etc/ssl/openssl.cnf -extensions v3_ca \
	   -signkey ${WORKDIR}/root.key -out ${WORKDIR}/root.crt
	openssl req -new -nodes -text -out ${WORKDIR}/server.csr -keyout ${WORKDIR}/server.key \
	   -subj "/CN=localhost"
	chmod og-rwx ${WORKDIR}/server.key
	openssl x509 -req -in ${WORKDIR}/server.csr -text -days 42 \
	   -CA ${WORKDIR}/root.crt -CAkey ${WORKDIR}/root.key \
	   -CAcreateserial -out ${WORKDIR}/server.crt
	openssl req -new -nodes -out ${WORKDIR}/client.csr -keyout ${WORKDIR}/client.key \
	   -subj "/CN=pgeltestuser"
	openssl x509 -req -days 42 -in ${WORKDIR}/client.csr \
	   -CA ${WORKDIR}/root.crt \
	   -CAkey ${WORKDIR}/root.key \
	   -CAcreateserial -out ${WORKDIR}/client.crt
	chmod 600 ${WORKDIR}/server.key
	ls -l ${WORKDIR}
	${DOCKER} volume create pgcerts
	tar cf ${WORKDIR}/certs.tar --directory=${WORKDIR} server.crt server.key root.crt
	${DOCKER} volume import pgcerts ${WORKDIR}/certs.tar
	${DOCKER} run --rm --name pgsqltls \
	   -v pgcerts:/certs:U \
	   --publish 5488:5488 \
	   -e POSTGRESQL_PORT_NUMBER=5488 \
	   -e POSTGRESQL_DATABASE=pgeltestdb \
	   -e POSTGRESQL_USERNAME=pgeltestuser \
	   -e POSTGRESQL_PASSWORD=pgeltest \
	   -e POSTGRESQL_ENABLE_TLS=yes \
	   -e POSTGRESQL_TLS_CERT_FILE=/certs/server.crt \
	   -e POSTGRESQL_TLS_KEY_FILE=/certs/server.key \
	   -e POSTGRESQL_TLS_CA_FILE=/certs/root.crt \
	   -e POSTGRESQL_PGHBA_REMOVE_FILTERS=local,md5,trust \
	   -d docker.io/bitnami/postgresql:latest
	sleep 5
	PGEL_CLIENT_CERT=${WORKDIR}/client.crt PGEL_CLIENT_CERT_KEY=${WORKDIR}/client.key PGEL_PORT=5488 ${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-client-cert

## emacs-pg-el 0.13+git.20130731.456516ec

=== debian/changelog ===
emacs-pg-el (0.13+git.20130731.456516ec-2) unstable; urgency=medium

  * Source-only upload.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 26 Jul 2020 14:29:58 -0700

emacs-pg-el (0.13+git.20130731.456516ec-1) unstable; urgency=low

  [ Matteo F. Vescovi & Sean Whitton ]
  * Initial release (Closes: #962816).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 14 Jun 2020 09:09:26 -0700

=== debian/control ===
Source: emacs-pg-el
Section: lisp
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders:
 Matteo F. Vescovi <mfv@debian.org>,
 Sean Whitton <spwhitton@spwhitton.name>,
Build-Depends:
 debhelper-compat (= 12),
 dh-elpa,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/cbbrowne/pg.el
Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git

Package: elpa-pg
Architecture: all
Depends:
 ${elpa:Depends},
 ${misc:Depends},
Recommends:
 emacs (>= 47.0),
Enhances:
 emacs,
 emacs25,
Built-Using:
 ${misc:Built-Using},
Description: Emacs Lisp interface for PostgreSQL
 This module lets you access the PostgreSQL object-relational DBMS from Emacs,
 using its socket-level frontend/backend protocol. The module is capable of
 automatic type coercions from a range of SQL types to the equivalent Emacs
 Lisp type.
 .
 This is a low level API, and won't be useful to end users.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/emacs-pg-el-$1\.tar\.gz/ \
https://github.com/cbbrowne/pg.el/tags .*/v?(\d\S+)\.tar\.gz

## emacs-pg-el 0.48

=== debian/changelog ===
emacs-pg-el (0.48-1) unstable; urgency=medium

  * New upstream release
  * Drop emacs25 from Enhances in d/control; no longer shipped since
    oldoldstable
  * Drop oldoldstable emacs version from Recommends in d/control
  * Update Standards-Version to 4.7.2; no change needed
  * Add patch to fix file mode of pg-geometry.el

 -- Xiyue Deng <manphiz@gmail.com>  Fri, 28 Feb 2025 01:48:54 -0800

emacs-pg-el (0.33-1) unstable; urgency=medium

  [ Sean Whitton ]
  * Remove myself from Uploaders.
  * Run 'wrap-and-sort -ast'.

  [ Xiyue Deng ]
  * Switch to new upstream at https://github.com/emarsden/pg-el (Closes:
    #1093398)
  * New upstream version
  * New maintainer (Closes: #1017880)
  * Update Homepage in d/control to track the new upstream
  * Update package description based on new upstream in d/control
  * Update d/watch to follow the new upstream
  * Update d/u/metadata with the new upstream info
  * Drop all patches as we are switching upstream
  * Drop d/s/{options,patch-header} now that patches are all dropped
  * Add d/gbp.conf matching the current practice
  * Update Standards-Version to 4.7.0; no change needed
  * Drop Built-Using from d/control
  * Update section to editors in d/control
  * Update copyright info for the new upstream in d/copyright
  * Add copyright info for doc/theme/highlight.js under BSD-3-Clause
  * Fix Sean's last name in d/copyright
  * Add d/docs to ship README.md
  * Add d/NEWS to announce switching to the new upstream
  * Add d/salsa-ci.yml with default template
  * Add doc/theme/highlight.js to d/missing-sources
  * Add lintian-overrides for highlight.js
    - The bundled highlight.js has higher version than the one available
      in Debian.
  * Add myself to debian/* clause in d/copyright
  * Update Standards-Version to 4.7.1; no change needed

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 26 Feb 2025 13:27:53 -0800

emacs-pg-el (0.13+git.20130731.456516ec-3) unstable; urgency=medium

  * Team upload.
  * Rebuild against dh-elpa 2.1.5.
    Upload pushed to dgit-repos but not salsa.
    See <https://lists.debian.org/debian-emacsen/2024/07/msg00077.html>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 25 Jul 2024 19:48:48 +0900

## emacs-pg-el 0.49

=== debian/changelog ===
emacs-pg-el (0.49-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 09 Mar 2025 20:52:00 -0700

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/" \
    https://github.com/emarsden/pg-el/tags \
    (?:.*/)?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate

## emacs-pg-el 0.51

=== debian/changelog ===
emacs-pg-el (0.51-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Mon, 31 Mar 2025 23:51:03 -0700

emacs-pg-el (0.50-1) unstable; urgency=medium

  * New upstream release
  * Drop 0001-Remove-executable-attribute-from-pg-geometry.el.patch
    - Applied upstream.

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 26 Mar 2025 10:28:56 -0700

## emacs-pg-el 0.52

=== debian/changelog ===
emacs-pg-el (0.52-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 09 Apr 2025 10:26:08 -0700

## emacs-pg-el 0.53

=== debian/changelog ===
emacs-pg-el (0.53-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Tue, 22 Apr 2025 22:18:32 -0700

## emacs-pg-el 0.54

=== test/Makefile ===
--- 
+++ 
@@ -58,24 +58,24 @@
 # Using Docker images for Emacs from https://hub.docker.com/r/silex/emacs/ and the locally installed
 # PostgreSQL.
 test-emacs-dev: test-pg.el
-	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el test-pg.el ${WORKDIR}
+	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el ../pg-bm25.el test-pg.el ${WORKDIR}
 	${DOCKER} run --rm -it \
 	   -v ${WORKDIR}:/tmp \
 	   -e DEPS_DIR=/tmp/deps \
 	   -e PGEL_HOSTNAME=10.0.2.2 \
 	   --network slirp4netns:allow_host_loopback=true \
 	   docker.io/silex/emacs:master-alpine-ci \
-	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l ../tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/test-pg.el -f pg-test
+	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l ../tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/pg-bm25.el -l /tmp/test-pg.el -f pg-test
 
 test-emacs28: test-pg.el
-	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el test-pg.el ${WORKDIR}
+	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el ../pg-bm25.el test-pg.el ${WORKDIR}
 	${DOCKER} run --rm -it \
 	   -v ${WORKDIR}:/tmp \
 	   -e DEPS_DIR=/tmp/deps \
 	   -e PGEL_HOSTNAME=10.0.2.2 \
 	   --network slirp4netns:allow_host_loopback=true \
 	   docker.io/silex/emacs:28.1 \
-	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/test-pg.el -f pg-test
+	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/pg-bm25.el -l /tmp/test-pg.el -f pg-test
 
 # The peg.el library doesn't actually compile with Emacs 27 (void-function byte-run--set-speed), so
 # this doesn't work.
@@ -299,4 +299,3 @@
 	   -e POSTGRESQL_PGHBA_REMOVE_FILTERS=local,md5,trust \
 	   -d docker.io/bitnami/postgresql:latest
 	sleep 5
-	PGEL_CLIENT_CERT=${WORKDIR}/client.crt PGEL_CLIENT_CERT_KEY=${WORKDIR}/client.key PGEL_PORT=5488 ${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-client-cert

=== debian/changelog ===
emacs-pg-el (0.54-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 04 May 2025 21:45:50 -0700

=== debian/control ===
Source: emacs-pg-el
Section: editors
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders:
 Matteo F. Vescovi <mfv@debian.org>,
 Xiyue Deng <manphiz@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 dh-elpa,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git
Homepage: https://github.com/emarsden/pg-el
Rules-Requires-Root: no

Package: elpa-pg
Architecture: all
Depends:
 ${elpa:Depends},
 ${misc:Depends},
Recommends:
 emacs,
Enhances:
 emacs,
Description: pg.el -- Emacs Lisp socket-level interface to the PostgreSQL RDBMS
 This module lets you access the PostgreSQL object-relational DBMS
 from Emacs, using its socket-level frontend/backend protocol. The
 module is capable of automatic type coercions from a range of SQL
 types to the equivalent Emacs Lisp type.
 .
 Supported features:
 .
  - SCRAM-SHA-256 authentication (the default method since PostgreSQL
    version 14) and MD5 authentication.
 .
  - Encrypted (TLS) connections between Emacs and the PostgreSQL
    backend.
 .
  - Support for the SQL COPY protocol to copy preformatted data to
    PostgreSQL from an Emacs buffer.
 .
  - Asynchronous handling of LISTEN/NOTIFY notification messages from
    PostgreSQL, allowing the implementation of publish-subscribe type
    architectures (PostgreSQL as an "event broker" or "message bus"
    and Emacs as event publisher and consumer).
 .
  - Support for PostgreSQL's extended query syntax, that allows for
    parameterized queries to protect from SQL injection issues.
 .
 This is a low level API, and won't be useful to end users. If you're
 looking for a browsing/editing interface to PostgreSQL, see the
 PGmacs module from https://github.com/emarsden/pgmacs/.

## emacs-pg-el 0.58

=== debian/changelog ===
emacs-pg-el (0.58-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Thu, 14 Aug 2025 22:07:15 -0700

## emacs-pg-el 0.59

=== test/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 test: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el ../pg.el \
-	   -l pg.el -l pg-geometry.el -l pg-gis.el -l test-pg.el -f pg-test
+	   -l pg.el -l pg-geometry.el -l pg-gis.el -l pg-lo.el -l test-pg.el -f pg-test
 
 test-interactive: test-pg.el install-deps
 	${EMACS} -Q -L .. -L . -l load-deps.el ../pg.el \
@@ -33,6 +33,7 @@
 test-tls: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls
 
+# This needs Emacs support for ALPN (currently unimplemented).
 test-tls-direct: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls-direct
 
@@ -116,19 +117,6 @@
 	   docker.io/silex/emacs:25.3 \
 	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/test-pg.el -f pg-test
 
-test-postgresql17: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5426:5426 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5426 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:17-alpine
-	sleep 5
-	PGEL_PORT=5426 $(MAKE) test
-	${DOCKER} stop pgsql
-
 # A special test for short usernames, database names, passwords and so on (we used to have some
 # builtin assumptions that a username was a least 4 chars in length).
 test-shortnames: test-pg.el
@@ -143,125 +131,12 @@
 	PGEL_PORT=5926 PGEL_DATABASE=d PGEL_USER=u PGEL_PASSWORD="~" $(MAKE) test
 	${DOCKER} stop pgsql
 
-test-postgresql16: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5416:5416 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5416 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:16-alpine
-	sleep 5
-	TZ=Asia/Tokyo PGEL_PORT=5416 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql15: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5116:5116 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5116 \
-	   -d docker.io/library/postgres:15
-	sleep 5
-	PGEL_PORT=5116 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql14: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5439:5439 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5439 \
-	   -d docker.io/library/postgres:14
-	sleep 5
-	PGEL_PORT=5439 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql13: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5439:5439 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5439 \
-	   -d docker.io/library/postgres:13-alpine
-	sleep 5
-	PGEL_PORT=5439 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql12: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5439:5439 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5439 \
-	   -d docker.io/library/postgres:12-alpine
-	sleep 5
-	PGEL_PORT=5439 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql11: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5437:5437 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5437 \
-	   -d docker.io/library/postgres:11-alpine
-	sleep 5
-	PGEL_PORT=5437 $(MAKE) test
-	${DOCKER} stop pgsql
-
-
-# EDB with a Red Hat Universal Base Image. This defaults to an SQL_ASCII client-encoding unless we
-# set LC_CTYPE.
+# Note that we need to tell Emacs GnuTLS to trust the root.crt file in order for it to accept the
+# PostgreSQL server TLS certificate (it's not signed by the system CA).
 #
-# https://github.com/EnterpriseDB/docker-postgresql
-test-enterprisedb: test-pg.el
-	${DOCKER} run --rm --name edb \
-	   --publish 5366:5366 \
-	   -e TZ=UTC-7:00 \
-	   -e LANG=en_US.UTF8 \
-	   -e LC_CTYPE=en_US.UTF8 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5366 \
-	   -d ghcr.io/enterprisedb/postgresql:17
-	TZ=UTC-7:00 PGEL_PORT=5366 $(MAKE) test
-	${DOCKER} stop edb
-
-
-# Tests with a PostgreSQL server configured to only accept clients that present a CA-signed certificate.
-#
-#   https://www.postgresql.org/docs/current/ssl-tcp.html
-#
-# We use openssl to generate a new Root certificate authority and key. Use the root CA to create a
-# server certificate and key and a client certificate and key. Start PostgreSQL with the server
-# certificate and the root CA certificate, configured to require clients to present a client
-# certificate signed by our root CA. Connect presenting the client certificate (this uses the GnuTLS
-# support for client certificates in Emacs).
-#
-# Note: mounting the pgcerts volume with the :U modifier maps the file owner for all volume files to
-# that selected by the container ("postgres"), which is required for PostgreSQL to accept that the
-# server certificate key is not readable by other users.
-#
-# https://github.com/bitnami/containers/blob/main/bitnami/postgresql/README.md
-#
-# The Bitnami configuration for pg_hba.conf deletes all lines with authentication methods
-# local, or md5, or trust (our value for POSTGRESQL_PHHBA_REMOVE_FILTERS), and adds a line
-#
-#   hostssl     all             all             0.0.0.0/0               cert
-#
-# This means the equivalent of clientcert=verify-full, meaning that the server will verify that the
-# client certificate is signed by its root CA (configured as /certs/root.crt below) and will also
-# verify that the username specified in the CN field of the certificate corresponds to the
-# PostgreSQL username we are connecting as.
-test-certificates: test-pg.el install-deps
+# Currently failing with Emacs 31.0.50 with
+#   LOG:  received direct SSL connection request without ALPN protocol negotiation extension
+test-postgresql18betatls: test-pg.el
 	openssl req -new -nodes -text -out ${WORKDIR}/root.csr -keyout ${WORKDIR}/root.key \
 	   -subj "/CN=localhost"
 	chmod og-rwx ${WORKDIR}/root.key
@@ -285,17 +160,167 @@
 	${DOCKER} volume create pgcerts
 	tar cf ${WORKDIR}/certs.tar --directory=${WORKDIR} server.crt server.key root.crt
 	${DOCKER} volume import pgcerts ${WORKDIR}/certs.tar
-	${DOCKER} run --rm --name pgsqltls \
-	   -v pgcerts:/certs:U \
-	   --publish 5488:5488 \
-	   -e POSTGRESQL_PORT_NUMBER=5488 \
-	   -e POSTGRESQL_DATABASE=pgeltestdb \
-	   -e POSTGRESQL_USERNAME=pgeltestuser \
-	   -e POSTGRESQL_PASSWORD=pgeltest \
-	   -e POSTGRESQL_ENABLE_TLS=yes \
-	   -e POSTGRESQL_TLS_CERT_FILE=/certs/server.crt \
-	   -e POSTGRESQL_TLS_KEY_FILE=/certs/server.key \
-	   -e POSTGRESQL_TLS_CA_FILE=/certs/root.crt \
-	   -e POSTGRESQL_PGHBA_REMOVE_FILTERS=local,md5,trust \
-	   -d docker.io/bitnami/postgresql:latest
-	sleep 5
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+           -v pgcerts:/certs:U \
+           --publish 5418:5418 \
+           -e POSTGRES_DB=pgeltestdb \
+           -e POSTGRES_USER=pgeltestuser \
+           -e POSTGRES_PASSWORD=pgeltest \
+           -e PGPORT=5418 \
+           -e TZ=Asia/Tokyo \
+           --user postgres \
+           -d docker.io/library/postgres:18beta3-alpine \
+              -c ssl=on \
+              -c ssl_cert_file=/certs/server.crt \
+              -c ssl_key_file=/certs/server.key
+	sleep 5
+	PGEL_TRUST_CA=${WORKDIR}/root.crt PGEL_PORT=5418 $(MAKE) test-tls-direct
+	${DOCKER} stop pgsql
+	sleep 2
+	${DOCKER} volume rm pgcerts
+
+
+test-postgresql18beta: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5418:5418 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5418 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:18beta3-alpine
+	sleep 5
+	PGEL_PORT=5418 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql18: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5418:5418 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5418 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:18-alpine
+	sleep 5
+	PGEL_PORT=5418 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql17: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5426:5426 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5426 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:17-alpine
+	sleep 5
+	PGEL_PORT=5426 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql16: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5416:5416 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5416 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:16-alpine
+	sleep 5
+	TZ=Asia/Tokyo PGEL_PORT=5416 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql15: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5116:5116 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5116 \
+	   -d docker.io/library/postgres:15
+	sleep 5
+	PGEL_PORT=5116 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql14: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5439:5439 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5439 \
+	   -d docker.io/library/postgres:14
+	sleep 5
+	PGEL_PORT=5439 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql13: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+	   --publish 5439:5439 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5439 \
+	   -d docker.io/library/postgres:13-alpine
+	sleep 5
+	PGEL_PORT=5439 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql12: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+	   --publish 5439:5439 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5439 \
+	   -d docker.io/library/postgres:12-alpine
+	sleep 5
+	PGEL_PORT=5439 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql11: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+	   --publish 5437:5437 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5437 \
+	   -d docker.io/library/postgres:11-alpine
+	sleep 5
+	PGEL_PORT=5437 $(MAKE) test
+	${DOCKER} stop pgsql
+
+
+# EDB with a Red Hat Universal Base Image. This defaults to an SQL_ASCII client-encoding unless we
+# set LC_CTYPE.
+#
+# https://github.com/EnterpriseDB/docker-postgresql
+test-enterprisedb: test-pg.el
+	${DOCKER} run --rm --name edb \
+	   --publish 5366:5366 \
+	   -e TZ=UTC-7:00 \
+	   -e LANG=en_US.UTF8 \
+	   -e LC_CTYPE=en_US.UTF8 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5366 \
+	   -d ghcr.io/enterprisedb/postgresql:17
+	TZ=UTC-7:00 PGEL_PORT=5366 $(MAKE) test
+	${DOCKER} stop edb
+
+
+# Tests with a PostgreSQL server configured to only accept clients that present a CA-signed certificate.
+#
+#   https://www.postgresql.org/docs/current/ssl-tcp.html
+#
+# We use openssl to generate a new Root certificate authority and key. Use the root CA to create a

=== debian/changelog ===
emacs-pg-el (0.59-1) unstable; urgency=medium

  * New upstream release
  * Migrate d/watch to rfc822-style version 5 format

 -- Xiyue Deng <manphiz@gmail.com>  Fri, 05 Sep 2025 21:54:12 -0700

## emacs-pg-el 0.60

=== test/Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 test-tls: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls
 
-# This needs Emacs support for ALPN (currently unimplemented).
+# This needs Emacs support for ALPN (currently under development).
 test-tls-direct: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls-direct
 
@@ -49,8 +49,11 @@
 test-connections: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-connection-tests
 
-test-multithreaded: test-pg.el install-deps
+test-multithreaded: test-multithreaded.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-multithreaded.el -f pgtest-multithreaded
+
+test-async: test-async.el install-deps
+	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-async.el -f pgtest-async
 
 test-pgvector: test-pgvector.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pgvector.el -f pg-test
@@ -130,6 +133,7 @@
 	sleep 5
 	PGEL_PORT=5926 PGEL_DATABASE=d PGEL_USER=u PGEL_PASSWORD="~" $(MAKE) test
 	${DOCKER} stop pgsql
+
 
 # Note that we need to tell Emacs GnuTLS to trust the root.crt file in order for it to accept the
 # PostgreSQL server TLS certificate (it's not signed by the system CA).
@@ -181,7 +185,7 @@
 	${DOCKER} volume rm pgcerts
 
 
-test-postgresql18beta: test-pg.el
+test-postgresql18: test-pg.el
 	${DOCKER} run --rm --name pgsql \
            --pull=newer \
 	   --publish 5418:5418 \
@@ -190,21 +194,7 @@
 	   -e POSTGRES_PASSWORD=pgeltest \
 	   -e PGPORT=5418 \
 	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:18beta3-alpine
-	sleep 5
-	PGEL_PORT=5418 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql18: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-           --pull=newer \
-	   --publish 5418:5418 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5418 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:18-alpine
+	   -d docker.io/library/postgres:18rc1-alpine
 	sleep 5
 	PGEL_PORT=5418 $(MAKE) test
 	${DOCKER} stop pgsql
@@ -324,3 +314,5 @@
 #   https://www.postgresql.org/docs/current/ssl-tcp.html
 #
 # We use openssl to generate a new Root certificate authority and key. Use the root CA to create a
+# server certificate and key and a client certificate and key. Start PostgreSQL with the server
+# certificate and the root CA certificate, configured to require clients to present a client

=== debian/changelog ===
emacs-pg-el (0.60-1) unstable; urgency=medium

  * New upstream release
  * Drop "Rules-Requires-Root" from d/control
    - This is now the default.

 -- Xiyue Deng <manphiz@gmail.com>  Thu, 25 Sep 2025 22:54:23 -0700

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,6 @@
 Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
 Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git
 Homepage: https://github.com/emarsden/pg-el
-Rules-Requires-Root: no
 
 Package: elpa-pg
 Architecture: all

=== debian/watch ===
Version: 5

Template: Github
Owner: emarsden
Project: pg-el

## emacs-pg-el 0.61

=== test/Makefile ===
--- 
+++ 
@@ -140,7 +140,7 @@
 #
 # Currently failing with Emacs 31.0.50 with
 #   LOG:  received direct SSL connection request without ALPN protocol negotiation extension
-test-postgresql18betatls: test-pg.el
+test-postgresql18tls: test-pg.el
 	openssl req -new -nodes -text -out ${WORKDIR}/root.csr -keyout ${WORKDIR}/root.key \
 	   -subj "/CN=localhost"
 	chmod og-rwx ${WORKDIR}/root.key
@@ -174,7 +174,7 @@
            -e PGPORT=5418 \
            -e TZ=Asia/Tokyo \
            --user postgres \
-           -d docker.io/library/postgres:18beta3-alpine \
+           -d docker.io/library/postgres:18-alpine \
               -c ssl=on \
               -c ssl_cert_file=/certs/server.crt \
               -c ssl_key_file=/certs/server.key
@@ -188,13 +188,13 @@
 test-postgresql18: test-pg.el
 	${DOCKER} run --rm --name pgsql \
            --pull=newer \
-	   --publish 5418:5418 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5418 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:18rc1-alpine
+           --publish 5418:5418 \
+           -e POSTGRES_DB=pgeltestdb \
+           -e POSTGRES_USER=pgeltestuser \
+           -e POSTGRES_PASSWORD=pgeltest \
+           -e PGPORT=5418 \
+           -e TZ=Asia/Tokyo \
+           -d docker.io/library/postgres:18-alpine
 	sleep 5
 	PGEL_PORT=5418 $(MAKE) test
 	${DOCKER} stop pgsql

=== debian/changelog ===
emacs-pg-el (0.61-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 26 Nov 2025 15:17:37 -0800

## emacs-pg-el 0.62

=== test/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 WORKDIR := $(shell mktemp -d)
 
 # export DEPS_DIR = $(shell realpath .deps)
-export DEPS_DIR := $(shell mktemp -d --tmpdir emacsdepsXXXX)
+export DEPS_DIR := $(shell mktemp -d -t emacsdepsXXXX)
 
 default: test
 
@@ -16,6 +16,7 @@
 test: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el ../pg.el \
 	   -l pg.el -l pg-geometry.el -l pg-gis.el -l pg-lo.el -l test-pg.el -f pg-test
+	rm -r ${DEPS_DIR}
 
 test-interactive: test-pg.el install-deps
 	${EMACS} -Q -L .. -L . -l load-deps.el ../pg.el \

=== debian/changelog ===
emacs-pg-el (0.62-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.7.3; no change needed
  * Drop `Priority: optional'; now default

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 31 Dec 2025 04:57:43 -0800

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: emacs-pg-el
 Section: editors
-Priority: optional
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
 Uploaders:
  Matteo F. Vescovi <mfv@debian.org>,
@@ -8,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-elpa,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
 Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git
 Homepage: https://github.com/emarsden/pg-el

## emacs-pg-el 0.63

=== test/Makefile ===
--- 
+++ 
@@ -297,6 +297,7 @@
 # https://github.com/EnterpriseDB/docker-postgresql
 test-enterprisedb: test-pg.el
 	${DOCKER} run --rm --name edb \
+           --pull=newer \
 	   --publish 5366:5366 \
 	   -e TZ=UTC-7:00 \
 	   -e LANG=en_US.UTF8 \

=== debian/changelog ===
emacs-pg-el (0.63-1) unstable; urgency=medium

  * New upstream release
  * Update my Debian copyright year in d/copyright

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 15 Feb 2026 03:58:54 -0800
